#!/usr/bin/env php
<?php
// -*- coding: UTF-8 -*-

//permettre de forcer l'affichage en direct lors de l'exécution
if(in_array("--help",$argv) || in_array("-h",$argv)) die("option unique pour obtenir l'affichage complet, absent par défaut : -v ou -V (verbose)\n");
elseif(in_array("-v",$argv) || in_array("-V",$argv)) $verbose = true;
else $verbose = false;

//paramètres généraux --> obligatoires car existence vérifiée par EnvoleTools
define('VERSION_APPLI','3'); //indique le nombre de mises à jour disponibles dans le fichier "update_appli.php" (utilisé par ajax-portail uniquement)	
define('APPLI_NAME','Cahier De Textes'); //pour affichage
define('APPLI_MODULE','cdt'); //pour noms de fichiers ou répertoires
define('APPLI_DICO','cdt'); //nom de la variable dans le gen_config
define('ABSPATH','/var/www/html/'.APPLI_MODULE.'/');

//paramètres de connexion qui seront affectés à l'application (DB_PASS sera généré par la librairie) --> obligatoires car existence vérifiée par EnvoleTools
define('DB_HOST','localhost');
define('DB_NAME','cdt');
define('DB_USER','cdt');
define('FILE_CONNEXION',ABSPATH.'Connections/conn_cahier_de_texte.php');

//classe générique qui gère les opérations utiles à l'installation et présente dans l'include_path du php.ini (/usr/share/php)
if(!is_file("/usr/share/php/envolePHP/EnvoleTools.class.php"))
die("\n---- INSTALLATION IMPOSSIBLE ----\nCause : le fichier \"/usr/share/php/envolePHP/EnvoleTools.class.php\" est introuvable. Réinstaller le paquet \"envole-php\".\n\n");
require_once("envolePHP/EnvoleTools.class.php");

//fonction à redéfinir pour chaque application et gérant la vérification des paramètres du fichier de connexion
function connexion_analyse()
	{
	global $install;

	if(!is_file(FILE_CONNEXION))
		{
		$install->afficher("Le fichier de connexion est introuvable... il va être recréé\n");
		$install->create_user = true;
		}
	else
		{	
		//récupération des paramètres de connexion
		//un header dans le fichier d'origine + un mysql_connect() oblige à analyser le fichier : méthode reprise de celle utilisée pour WebCalendar
		$install->afficher("Lecture des paramètres de connexion... ");
		$cdt_parametres = array("hostname_conn_cahier_de_texte","username_conn_cahier_de_texte","password_conn_cahier_de_texte","database_conn_cahier_de_texte"); //paramètres à vérifier
		$cdt_file = file_get_contents(FILE_CONNEXION);
		$cdt_file = preg_replace("/[\r\n]+/","\n",$cdt_file);
		$cdt_content = explode("\n",$cdt_file);
		for($n=0; $n<count($cdt_content); $n++)
			{
			$buffer = $cdt_content[$n];
			$buffer = trim($buffer,"\r\n ");
			if(preg_match("/^(#|\/\*|<\?|\?>)/",$buffer)) continue;
			if(preg_match("/(\S+)\s*=\s*(\S+)\s*;/",$buffer,$matches))
				{
				$param = substr($matches[1],1);
				if(in_array($param,$cdt_parametres))
					{
					$valeur = substr($matches[2],1,-1);
					$$param = $valeur;
					unset($cdt_parametres[array_search($param,$cdt_parametres)]);
					}
				}
			}	
		$install->afficher("OK\n");

		//tester la validité des paramètres obtenus
		if(count($cdt_parametres)!=0) //paramètre absent
			{
			$install->afficher("Le fichier de connexion est incomplet... il va être réécrit\n");
			$install->create_user = true;
			}	
		elseif(!$install->test($hostname_conn_cahier_de_texte,$username_conn_cahier_de_texte,$password_conn_cahier_de_texte,$database_conn_cahier_de_texte))
			{
			$install->afficher("Les paramètres sont incorrects... ils vont être mis à jour\n");
			$install->create_user = true;
			}
		else //précaution : bon propriétaire et surtout bons droits car si "w", message d'avertissement dans le cahier de textes...
			{
			exec("chown root:www-data ".FILE_CONNEXION);
			exec("chmod 640 ".FILE_CONNEXION);
			}
		}
	}

//fonction à redéfinir pour chaque application et gérant la création du fichier de connexion
function connexion_creation()
	{
	global $install;
	
	$install->afficher("Création du fichier de connexion... ");
	
	//reprise de la fonction EcrireFichier() de install/install_param2.php
	$fp = @fopen(FILE_CONNEXION,"w");
	if(!$fp) $install->echec("Erreur > Ouverture du fichier de configuration\n\n");
	$data = "<?php\n";
	$data.= " \$hostname_conn_cahier_de_texte = \"".DB_HOST."\";\n";
	$data.= " \$database_conn_cahier_de_texte = \"".DB_NAME."\";\n";
	$data.= " \$username_conn_cahier_de_texte = \"".DB_USER."\";\n";
	$data.= " \$password_conn_cahier_de_texte = \"".DB_PASS."\";\n";
	$data.= " \$conn_cahier_de_texte = mysql_connect(\$hostname_conn_cahier_de_texte, \$username_conn_cahier_de_texte, \$password_conn_cahier_de_texte) or die(mysql_error());\n";
	$data.= "?>";
	if(!@fwrite($fp,$data)) $install->echec("Erreur > Ecriture du fichier de configuration\n\n");
	if(!@fclose($fp)) $install->echec("Erreur > Fermeture du fichier de configuration\n\n");

	$install->resultat(is_file(FILE_CONNEXION));

	//bon propriétaire et surtout bons droits car si "w", message d'avertissement dans le cahier de textes...
	exec("chown root:www-data ".FILE_CONNEXION);
	exec("chmod 640 ".FILE_CONNEXION);
	}

//démarrage réel de l'installation qui ouvre notamment le fichier de log et récupère certaines variables du Scribe
$install = new EnvoleTools($verbose);

//condition pour l'installation spécifique dans ajax-portail donc voué à disparaître
if(defined("SCRIBE_ENVOLE") && SCRIBE_ENVOLE=="oui") define('AJAX_PORTAIL',true);
else define('AJAX_PORTAIL',false);

//paramètres de la base "portal" donc voué à disparaître
if(AJAX_PORTAIL)
	{
	$install->afficher("Récupération de paramètres concernant le portail EnvOLE... ");
	if(is_file("/var/www/html/envole/serverdata.php"))
		{
		require_once("/var/www/html/envole/serverdata.php");
		define("PORTAL_NAME",$dbName);
		define("PORTAL_PREFIX",$dbPfix);
		$install->afficher("OK\n");
		}
	else $install->echec("Echec\nAVERTISSEMENT : Le paquet \"ajax-portail\" doit être installé avant le ".APPLI_NAME." -> Installation interrompue.\n\n");
	}

$install->echo_sstitre("Analyse de la base \"".DB_NAME."\" et des paramètres de connexion");

//vérification de la base de données
if($install->bdd_verification()) connexion_analyse();

//traitement de création éventuelle base/user
$install->bdd_traitement();

//création éventuelle du fichier de connexion
if($install->create_user) connexion_creation();

//simple vérification de la présence des fichiers de configuration nécessaires pour assurer le SSO
$install->echo_sstitre("Vérification du paramétrage du serveur CAS");
$install->afficher("Présence du fichier \"".APPLI_MODULE.".ini\"... ");
if(is_file(DIR_FILTER.APPLI_MODULE.".ini")) $install->afficher("OK\n");
else $install->echec("Echec\nAVERTISSEMENT : Le fichier \"".DIR_FILTER.APPLI_MODULE.".ini\" est introuvable -> Installation interrompue.\nLe paquet aurait dû le fournir.\n\n");
$install->afficher("Présence du fichier \"profil_".APPLI_MODULE.".py\"... ");
if(is_file(DIR_INFOS."profil_".APPLI_MODULE.".py")) $install->afficher("OK\n");
else $install->echec("Echec\nAVERTISSEMENT : Le fichier \"".DIR_INFOS."profil_".APPLI_MODULE.".py\" est introuvable -> Installation interrompue.\nLe paquet aurait dû le fournir.\n\n");

//sauvegarde de la base avant toute mise à jour (si la base existait déjà sinon on obtient un fichier vide...)
if(!$install->create_base)
	{
	$install->echo_sstitre("Sauvegarde de la base avant toute mise à jour");
	$install->dump(DB_NAME);
	}

//installation/maj par le processus propre à l'application mais automatisé dans install_appli.php
$install->echo_titre("Procédure d'installation/maj propre à l'application");
if(!is_file($install->rep_exec."install_".APPLI_MODULE.".php")) $install->echec("\nLe fichier \"".$install->rep_exec."install_".APPLI_MODULE.".php\" est introuvable -> Installation interrompue.\nLe paquet aurait dû le fournir.\n\n");
include_once($install->rep_exec."install_".APPLI_MODULE.".php");

//maj supplémentaire propre à ajax-portail donc voué à disparaître
if(AJAX_PORTAIL)
	{
	$install->echo_titre("Traitement des mises à jour spécifiques pour ".APPLI_NAME);
	$install->afficher("\nNuméro de mise à jour indiqué dans la base : ");
	$install->setRows("SELECT `value` FROM `".PORTAL_PREFIX."ajaxp_settings` WHERE `param`='VERSION_".strtoupper(APPLI_MODULE)."' LIMIT 1;",PORTAL_NAME);
	if(count($install->rows)===0) //premier reconfigure suite à l'activation d'envole 1.5
		{
		$install->query("INSERT INTO `".PORTAL_PREFIX."ajaxp_settings` (param, affichage, value, writable, visible, categorie) VALUES 
		('OUTIL_CDT', 'Cahier de textes', '<img border=\"0\" width=\"50\" height=\"50\" src=\"images/nuvola/64x64/apps/package_edutainment.gif\" style=\"CURSOR: pointer\" title=\"Cahier de textes\" onclick=\"openURL(''CDT '',''/cdt/authentification/auth.php'');\"/>', 0, 0, 'Menu_Outils'),
		('VERSION_CDT', 'Numéro de version CDT', ".VERSION_APPLI.", 0, 0, 'Version'),
		('VERSION_CDT_ACADEMIQUE', 'Numéro de version CDT académique', 0, 0, 0, 'Version');",PORTAL_NAME);
		
		$etape_maj = VERSION_APPLI;		
		}
	else $etape_maj = $install->rows[0]["value"];
	$install->afficher($etape_maj."\n");
	if(!is_file($install->rep_exec."update_".APPLI_MODULE.".php")) $install->echec("\nLe fichier \"".$install->rep_exec."update_".APPLI_MODULE.".php\" est introuvable -> Installation interrompue.\nLe paquet aurait dû le fournir.\n\n");
	include_once($install->rep_exec."update_".APPLI_MODULE.".php");
	update($etape_maj);
	}	
?>
