<?php
define('VERSION_CDT','4937'); //voir variable $indice_version au début du fichier "index.php"
define('SCRIPT_CDT','administration/misajour/maj_envole.php'); //script gérant les requêtes sql

//faire une requête HTTP
function requeteHTTP($uri,$post=array(),$https=false)
	{
	global $install,$fichier_maj;
	$url = $https ? 'https://'.$uri : 'http://'.$uri;

	//précaution : on redonne momentanément les droits de lecture à "www-data"
	exec("chown root:www-data ".$fichier_maj);
	exec("chmod 640 ".$fichier_maj);

	$curl = curl_init();
	if(curl_errno($curl)) $install->echec("Echec d'une requête cURL : ".curl_error($curl));
	curl_setopt($curl,CURLOPT_URL,$url);
	curl_setopt($curl,CURLOPT_POST,true);
	curl_setopt($curl,CURLOPT_POSTFIELDS,$post);
	curl_setopt($curl,CURLOPT_RETURNTRANSFER,true);
	curl_setopt($curl,CURLOPT_SSL_VERIFYPEER,0);
        curl_setopt($curl,CURLOPT_FOLLOWLOCATION,false);
	$resultat = curl_exec($curl);
	if(curl_errno($curl)) $install->echec("Echec d'une requête cURL : ".curl_error($curl));
	$code = curl_getinfo($curl,CURLINFO_HTTP_CODE);
	curl_close($curl);

	//précaution : on limite de nouveau l'accès à "root"
	exec("chmod 600 ".$fichier_maj);

	//utiliser CURLOPT_FOLLOWLOCATION ne résoud pas le problème de redirection possible HTTP vers HTTPS : le résultat retourné est vide et la mise à jour non faite
	//voir ce qui est fait là : http://www.php.net/manual/fr/function.curl-setopt.php#102121
	//ici, on relance la requête en HTTPS si redirection déclarée
	if(!$https && $code=="302")
		{
		$install->afficher("redirection https... ");
		return requeteHTTP($uri,$post,true);
		}
	else if($resultat!==false) return $resultat;
	else return false;	
	}

//génération du lien manuel de maj
function getLienManuel($url,$variables)
	{
	global $fichier_maj;
	$query_string = "";
	$separateur = "?";
	foreach($variables as $k=>$v)
		{
		$query_string .= $separateur.$k."=".urlencode($v);
		$separateur = "&";
		}
	$message = "\n\nPour effectuer manuellement l'opération, donner momentanément les droits en lecture à \"www-data\" sur le fichier \"".$fichier_maj."\" et utiliser le lien suivant :";
	$message .= "\n".$url.$query_string."\n";
	return $message;
	}

$install->afficher("Etat de la base de données... ");

$uri = ENVOLE_URL.'/cdt/'.SCRIPT_CDT;
$fichier_maj = ABSPATH.SCRIPT_CDT;
if(!is_file($fichier_maj)) $install->echec("absence du fichier \"".$fichier_maj."\"");

$install->setRows("SHOW TABLES",DB_NAME);
if(count($install->rows)===0)
	{
	$install->afficher("installation des tables... ");
	$variables = array();
	$variables['install'] = 1;
	$variables['nom_etab'] = utf8_decode(LIBELLE_ETAB); //car le fichier appelé attend de l'iso
	$variables['url_etab'] = utf8_decode("https://".ENVOLE_URL);
	//$variables['url_logo_etab'] = "";
	$resultat = requeteHTTP($uri,$variables);
	if($resultat===false || !preg_match("/INSTALL_OK/",$resultat))
		{
		$message = "\n\nRetour de l'installation des tables :";
		$message .= ($resultat===false) ? " problème de requête HTTP" : "\n".$resultat;
		$message .= getLienManuel('http://'.$uri,$variables);
		$install->echec($message);
		}
	}
else
	{
	$install->afficher("tables présentes... ");
	$install->setRows("SELECT `param_val` FROM `cdt_params` WHERE `param_nom`='ind_maj_base';",DB_NAME);
	if(count($install->rows)===0) $install->afficher("version non identifiée... aucune mise à jour... ");
	else
		{
		$version = $install->rows[0]["param_val"];
		if($version<VERSION_CDT)
			{
			$install->afficher("mise à jour de ".$version." vers ".VERSION_CDT."... ");

			//mise à jour prévue par l'application
			$variables = array();
			$variables['maj'] = 1;
			$resultat = requeteHTTP($uri,$variables);
			if($resultat===false || !preg_match("/MAJ_OK/",$resultat))
				{
				$message = "\n\nRetour de la mise à jour des tables :";
				$message .= ($resultat===false) ? " problème de requête HTTP" : "\n*".$resultat."*";
				$message .= getLienManuel('http://'.$uri,$variables);
				$install->echec($message);
				}
			}
		else $install->afficher("version ".$version." à jour... ");
		}
	}
$install->afficher("OK\n");

$install->afficher("Mise à jour de paramètres... ");

//ajout envole : sondes piwik
$install->setRows("SELECT `param_val` FROM `cdt_params` WHERE `param_nom`='envole_piwik_url';",DB_NAME);
if(count($install->rows)===0)
	{
	$install->query("INSERT INTO `cdt_params` (`param_nom`,`param_val`,`param_desc`) VALUES ('envole_piwik_url','','url d''accès à l''application piwik sans le protocole HTTP')",DB_NAME);
	
	//on en profite pour effectuer la mise à jour prévue par l'ajout d'une limitation d'accès anonyme (sera intégré dans la version 4.9.0.4)
	//pas très bien placé mais pour éviter que les requêtes soient exécutées plusieurs fois (maj dev,candidate,...)
	if(VERSION_CDT=="4902")
		{
		$install->query("ALTER TABLE `cdt_classe` CHANGE `passe_classe` `passe_classe` VARCHAR( 32 ) CHARACTER SET latin1 COLLATE latin1_swedish_ci NULL DEFAULT NULL;",DB_NAME);
		$install->query("UPDATE `cdt_classe` SET `passe_classe` = md5(`passe_classe`) WHERE `passe_classe`!='' AND `passe_classe` IS NOT NULL;",DB_NAME);
		}
	}
$install->setRows("SELECT `param_val` FROM `cdt_params` WHERE `param_nom`='envole_piwik_idsite';",DB_NAME);
if(count($install->rows)===0) $install->query("INSERT INTO `cdt_params` (`param_nom`,`param_val`,`param_desc`) VALUES ('envole_piwik_idsite','0','identifiant de l''application cdt dans piwik')",DB_NAME);

$install->setRows("SELECT `param_val` FROM `cdt_params` WHERE `param_nom`='envole_domaine';",DB_NAME);
if(count($install->rows)===0) $install->query("INSERT INTO `cdt_params` (`param_nom`,`param_val`,`param_desc`) VALUES ('envole_domaine','".ENVOLE_URL."','nom de domaine du Scribe')",DB_NAME);
elseif($install->rows[0]["param_val"]!=ENVOLE_URL) $install->query("UPDATE `cdt_params` SET `param_val`='".ENVOLE_URL."' WHERE `param_nom`='envole_domaine';",DB_NAME);

//précaution : mise à jour systématique de certains paramètres
$install->query("UPDATE `cdt_params` SET `param_val`='Non' WHERE `param_nom`='modif_login';",DB_NAME);
$install->query("UPDATE `cdt_params` SET `param_val`='Non' WHERE `param_nom`='modif_passe';",DB_NAME);
$install->query("UPDATE `cdt_params` SET `param_val`='index.php' WHERE `param_nom`='url_deconnecte_eleve';",DB_NAME); //redirection dans "consulter.php" pour permettre une déconnexion globale
$install->query("UPDATE `cdt_params` SET `param_val`='index.php' WHERE `param_nom`='url_deconnecte_prof';",DB_NAME); //redirection dans "deconnexion.php" pour déconnexion globale (CAS)

$install->afficher("OK\n");
?>
